Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ExpressionInterpreter.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ExpressionInterpreter.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ExpressionInterpreter.cs	(revision 11732)
@@ -54,16 +54,18 @@
       var r = 0.0;
       r = Term(d);
-      while (CurSy() == '+' || CurSy() == '-' || CurSy() == '^') {
-        if (CurSy() == '+') {
+      var curSy = CurSy();
+      while (curSy == '+' || curSy == '-' || curSy == '^') {
+        if (curSy == '+') {
           NewSy();
           r += Expr(d);
-        } else if (CurSy() == '-') {
+        } else if (curSy == '-') {
           NewSy();
           r -= Expr(d);
-        } else if (CurSy() == '^') {
+        } else {
           NewSy();
           var e = Expr(d);
           r = Not(r) * e + r * Not(e); // xor = (!x AND y) OR (x AND !y)
         }
+        curSy = CurSy();
       }
       return r;
@@ -73,12 +75,14 @@
       var r = 0.0;
       r = Fact(d);
-      while (CurSy() == '*' || CurSy() == '/') {
-        if (CurSy() == '*') {
+      var curSy = CurSy();
+      while (curSy == '*' || curSy == '/') {
+        if (curSy == '*') {
           NewSy();
           r *= Term(d);
-        } else if (CurSy() == '/') {
+        } else {
           NewSy();
           r /= Term(d);
         }
+        curSy = CurSy();
       }
       return r;
@@ -87,18 +91,21 @@
     private double Fact(double[] d) {
       double r = 0.0;
-      if (CurSy() == '!') {
+      var curSy = CurSy();
+      if (curSy == '!') {
         NewSy();
         r = Not(Expr(d));
-      } else if (CurSy() == '(') {
+      } else if (curSy == '(') {
         NewSy();
         r = Expr(d);
         if (CurSy() != ')') throw new ArgumentException();
         NewSy();
-      } else if (CurSy() >= 'a' && CurSy() <= 'z') {
-        int o = Convert.ToByte(CurSy()) - Convert.ToByte('a');
+      } else /* if (curSy >= 'a' && curSy <= 'z') */ {
+        int o = (byte)curSy - (byte)'a';
+        //int o = Convert.ToByte(CurSy()) - Convert.ToByte('a');
         if (o < 0 || o >= d.Length) throw new ArgumentException();
         r = d[o];
         NewSy();
-      } else throw new ArgumentException();
+      }
+      //} else throw new ArgumentException();
       return r;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Grammar.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Grammar.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Grammar.cs	(revision 11732)
@@ -35,12 +35,12 @@
       this.rules = new Dictionary<char, List<Sequence>>();
       foreach (var r in orig.rules)
-        this.rules.Add(r.Key, new List<Sequence>(r.Value.Select(v => new Sequence(v)))); // clone sequences
+        this.rules.Add(r.Key, new List<Sequence>(r.Value.Select(v => new ReadonlySequence(v)))); // clone sequences
       this.terminalSymbols = new HashSet<char>(orig.terminalSymbols);
       this.sentenceSymbol = orig.sentenceSymbol;
       this.nonTerminalSymbols = new HashSet<char>(orig.nonTerminalSymbols);
       this.maxPhraseLength = new Dictionary<Sequence, int>();
-      foreach (var p in orig.maxPhraseLength) this.maxPhraseLength.Add(new Sequence(p.Key), p.Value);
+      foreach (var p in orig.maxPhraseLength) this.maxPhraseLength.Add(new ReadonlySequence(p.Key), p.Value);
       this.minPhraseLength = new Dictionary<Sequence, int>();
-      foreach (var p in orig.minPhraseLength) this.minPhraseLength.Add(new Sequence(p.Key), p.Value);
+      foreach (var p in orig.minPhraseLength) this.minPhraseLength.Add(new ReadonlySequence(p.Key), p.Value);
     }
 
@@ -54,9 +54,9 @@
       foreach (var r in rules) {
         if (!this.rules.ContainsKey(r.Item1)) this.rules.Add(r.Item1, new List<Sequence>());
-        this.rules[r.Item1].Add(new Sequence(r.Item2)); // here we store an array of symbols for a phase
+        this.rules[r.Item1].Add(new ReadonlySequence(r.Item2)); // here we store an array of symbols for a phase
       }
 
       CheckValidity();
-      CalculatePhaseLengthBounds();
+      CalculatePhraseLengthBounds();
     }
 
@@ -76,7 +76,5 @@
     }
 
-    private void CalculatePhaseLengthBounds() {
-      minPhraseLength.Clear();
-      maxPhraseLength.Clear();
+    private void CalculatePhraseLengthBounds() {
       // cache phrase lengths
       foreach (var nt in nonTerminalSymbols) {
@@ -84,15 +82,14 @@
         var max = int.MinValue;
         foreach (var alt in rules[nt].OrderBy(alt => alt.Length)) {
-          minPhraseLength[alt] = MinPhraseLength(alt);
-          maxPhraseLength[alt] = MaxPhraseLength(alt);
+          CalcAndSetMinPhraseLength(alt);
+          CalcAndSetMaxPhraseLength(alt);
 
           min = Math.Min(min, minPhraseLength[alt]);
           max = Math.Max(max, maxPhraseLength[alt]);
         }
-        minPhraseLength[new Sequence(nt)] = min;
-        maxPhraseLength[new Sequence(nt)] = max;
-      }
-    }
-
+        minPhraseLength[new ReadonlySequence(nt)] = min;
+        maxPhraseLength[new ReadonlySequence(nt)] = max;
+      }
+    }
 
     public IEnumerable<Sequence> GetAlternatives(char nt) {
@@ -108,6 +105,11 @@
     }
 
-    // caches for this are build in construction of object
-    public int MinPhraseLength(Sequence phrase) {
+    #region population of minphraselength cache
+    private int CalcAndSetMinSymbolLength(char symb) {
+      if (IsTerminal(symb)) return 1;
+      else return Math.Min(short.MaxValue, rules[symb].Min(alt => CalcAndSetMinPhraseLength(alt))); // maximal allowed value is short.MaxValue
+    }
+    private int CalcAndSetMinPhraseLength(Sequence phrase) {
+      Debug.Assert(phrase is ReadonlySequence);
       int l;
       if (minPhraseLength.TryGetValue(phrase, out l)) return l;
@@ -116,9 +118,5 @@
 
       foreach (var symb in phrase) {
-        if (IsNonTerminal(symb)) {
-          l += MinSymbolLength(symb);
-        } else {
-          l++;
-        }
+        l += CalcAndSetMinSymbolLength(symb);
       }
 
@@ -127,7 +125,28 @@
       return l;
     }
-
+    #endregion
+
+    // read only access to caches
+    private int MinSymbolLength(char symb) {
+      if (IsTerminal(symb)) return 1;
+      else return Math.Min(short.MaxValue, rules[symb].Min(alt => MinPhraseLength(alt))); // maximal allowed value is short.MaxValue
+    }
+    public int MinPhraseLength(Sequence phrase) {
+      var minLen = 0;
+      if (minPhraseLength.TryGetValue(phrase, out minLen)) return minLen;
+      foreach (var s in phrase) {
+        minLen += MinSymbolLength(s);
+      }
+      return Math.Min(short.MaxValue, minLen); // maximal allowed value is short.MaxValue
+    }
+
+    #region population of maxphraselength cache
+    private int CalcAndSetMaxSymbolLength(char symb) {
+      if (IsTerminal(symb)) return 1;
+      else return Math.Min(short.MaxValue, rules[symb].Max(alt => CalcAndSetMaxPhraseLength(alt))); // maximal allowed value is short.MaxValue
+    }
     // caches for this are build in construction of object
-    public int MaxPhraseLength(Sequence phrase) {
+    private int CalcAndSetMaxPhraseLength(Sequence phrase) {
+      Debug.Assert(phrase is ReadonlySequence);
       int l;
       if (maxPhraseLength.TryGetValue(phrase, out l)) return l;
@@ -136,9 +155,5 @@
 
       foreach (var symb in phrase) {
-        if (IsNonTerminal(symb)) {
-          l += MaxSymbolLength(symb);
-        } else {
-          l++;
-        }
+        l += CalcAndSetMaxSymbolLength(symb);
       }
       l = Math.Min(short.MaxValue, l); // maximal allowed value is short.MaxValue
@@ -146,12 +161,18 @@
       return l;
     }
-
-    private int MinSymbolLength(char nt) {
-      if (IsTerminal(nt)) return 1;
-      else return Math.Min(short.MaxValue, rules[nt].Min(alt => MinPhraseLength(alt))); // maximal allowed value is short.MaxValue
-    }
-    private int MaxSymbolLength(char nt) {
-      if (IsTerminal(nt)) return 1;
-      else return Math.Min(short.MaxValue, rules[nt].Max(alt => MaxPhraseLength(alt))); // maximal allowed value is short.MaxValue
+    #endregion
+
+    // read only access to caches
+    public int MaxSymbolLength(char symb) {
+      if (IsTerminal(symb)) return 1;
+      else return Math.Min(short.MaxValue, rules[symb].Max(alt => MaxPhraseLength(alt))); // maximal allowed value is short.MaxValue 
+    }
+    public int MaxPhraseLength(Sequence phrase) {
+      var maxLen = 0;
+      if (maxPhraseLength.TryGetValue(phrase, out maxLen)) return maxLen;
+      foreach (var s in phrase) {
+        maxLen += MaxSymbolLength(s);
+      }
+      return Math.Min(short.MaxValue, maxLen); // maximal allowed value is short.MaxValue
     }
 
@@ -159,6 +180,5 @@
       if (phrase.Length > maxLen) throw new ArgumentException();
       if (MinPhraseLength(phrase) > maxLen) throw new ArgumentException();
-      bool done = phrase.IsTerminal; // terminal phrase means we are done
-      while (!done) {
+      while (!phrase.IsTerminal) {
         char nt = phrase.FirstNonTerminal;
 
@@ -173,5 +193,4 @@
         phrase.ReplaceAt(phrase.FirstNonTerminalIndex, 1, selectedAlt);
 
-        done = phrase.All(IsTerminal); // terminal phrase means we are done
       }
       return phrase;
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HardPalindromeProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HardPalindromeProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HardPalindromeProblem.cs	(revision 11732)
@@ -18,5 +18,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       // the whole sentence is a palindrome + each symbol occurs only once or twice
       // for odd total length the number of different characters can be larger than len/2 (aba)
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.csproj
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.csproj	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization.csproj	(revision 11732)
@@ -46,4 +46,5 @@
     <Compile Include="Grammar.cs" />
     <Compile Include="EvenParityProblem.cs" />
+    <Compile Include="ReadonlySequence.cs" />
     <Compile Include="SentenceSetStatistics.cs" />
     <Compile Include="Sequence.cs" />
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/IProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/IProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/IProblem.cs	(revision 11732)
@@ -6,5 +6,5 @@
 namespace HeuristicLab.Problems.GrammaticalOptimization {
   public interface IProblem {
-    double GetBestKnownQuality(int maxLen);
+    double BestKnownQuality(int maxLen);
     IGrammar Grammar { get; }
     double Evaluate(string sentence);
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/PalindromeProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/PalindromeProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/PalindromeProblem.cs	(revision 11732)
@@ -18,5 +18,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       // the whole sentence is a palindrome
       return maxLen;
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ReadonlySequence.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ReadonlySequence.cs	(revision 11732)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/ReadonlySequence.cs	(revision 11732)
@@ -0,0 +1,38 @@
+using System;
+
+namespace HeuristicLab.Problems.GrammaticalOptimization {
+  public class ReadonlySequence : Sequence {
+    public ReadonlySequence(string s)
+      : base(s) {
+    }
+
+    public ReadonlySequence(char ch)
+      : base(ch) {
+    }
+
+    public ReadonlySequence(Sequence s)
+      : base(s) {
+    }
+
+    public override void ReplaceAt(int position, int len, Sequence replacement) {
+      throw new NotSupportedException();
+    }
+
+    public override bool Equals(object obj) {
+      var other = obj as Sequence;
+      if (other == null) return false;
+      if (other.Length != this.Length) return false;
+      for (int i = 0; i < Length; i++)
+        if (other[i] != this[i]) return false;
+
+      // length and all symbols are the same
+      return true;
+    }
+
+    public override int GetHashCode() {
+      int h = 31 * Length;
+      foreach (var ch in this) { h += 31 * (byte)h; }
+      return h;
+    }
+  }
+}
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalPairProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalPairProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalPairProblem.cs	(revision 11732)
@@ -19,5 +19,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       return maxLen - 1;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalRoadProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalRoadProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalRoadProblem.cs	(revision 11732)
@@ -17,5 +17,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       // for now only an upper bound is returned, ideally all fitness cases are predicted correctly
       throw new NotImplementedException();
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalSymbolProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalSymbolProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalSymbolProblem.cs	(revision 11732)
@@ -19,5 +19,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       return maxLen;
     }
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalTreeProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalTreeProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/RoyalTreeProblem.cs	(revision 11732)
@@ -17,5 +17,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       // for now only an upper bound is returned, ideally all fitness cases are predicted correctly
       throw new NotImplementedException();
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SantaFeAntProblem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SantaFeAntProblem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SantaFeAntProblem.cs	(revision 11732)
@@ -23,5 +23,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       // for now only an upper bound is returned, ideally all food pellets are discovered
       return 89;
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/Sequence.cs	(revision 11732)
@@ -84,5 +84,5 @@
     }
 
-    public void ReplaceAt(int position, int len, Sequence replacement) {
+    public virtual void ReplaceAt(int position, int len, Sequence replacement) {
       if (replacement == null) throw new ArgumentNullException();
       if (len <= 0) throw new ArgumentException();
@@ -125,8 +125,8 @@
 
     public Sequence Subsequence(int startIdx, int len) {
-      if (startIdx < 0 || len <= 0) throw new ArgumentException();
+      if (startIdx < 0 || len < 0) throw new ArgumentException();
       if (startIdx >= this.len) throw new ArgumentException();
       if (startIdx + len > this.len) throw new ArgumentException();
-      var subsequence = new Sequence {len = len};
+      var subsequence = new Sequence { len = len };
 
       Array.Copy(this.symbols, startIdx, subsequence.symbols, 0, len);
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SymbolicRegressionPoly10Problem.cs
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SymbolicRegressionPoly10Problem.cs	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/HeuristicLab.Problems.GrammaticalOptimization/SymbolicRegressionPoly10Problem.cs	(revision 11732)
@@ -56,5 +56,5 @@
     }
 
-    public double GetBestKnownQuality(int maxLen) {
+    public double BestKnownQuality(int maxLen) {
       // for now only an upper bound is returned, ideally we have an R² of 1.0
       // the optimal R² can only be reached for sentences of at least 23 symbols
@@ -67,25 +67,7 @@
 
     public double Evaluate(string sentence) {
-      return RSq(y, Enumerable.Range(0, N).Select(i => interpreter.Interpret(sentence, x[i])).ToArray());
+      return HeuristicLab.Common.Extensions.RSq(y, Enumerable.Range(0, N).Select(i => interpreter.Interpret(sentence, x[i])).ToArray());
     }
 
-    private double RSq(IEnumerable<double> xs, IEnumerable<double> ys) {
-      // two pass implementation, but we don't care
-      var meanX = xs.Average();
-      var meanY = ys.Average();
-
-      var s = 0.0;
-      var ssX = 0.0;
-      var ssY = 0.0;
-      foreach (var p in xs.Zip(ys, (x, y) => new { x, y })) {
-        s += (p.x - meanX) * (p.y - meanY);
-        ssX += Math.Pow(p.x - meanX, 2);
-        ssY += Math.Pow(p.y - meanY, 2);
-      }
-
-      if (s.IsAlmost(0)) return 0;
-      if (ssX.IsAlmost(0) || ssY.IsAlmost(0)) return 0;
-      return s * s / (ssX * ssY);
-    }
 
 
Index: branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Main.csproj
===================================================================
--- branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Main.csproj	(revision 11731)
+++ branches/HeuristicLab.Problems.GrammaticalOptimization/Main/Main.csproj	(revision 11732)
@@ -57,4 +57,8 @@
       <Name>HeuristicLab.Algorithms.GrammaticalOptimization</Name>
     </ProjectReference>
+    <ProjectReference Include="..\HeuristicLab.Problems.GrammaticalOptimization.SymbReg\HeuristicLab.Problems.GrammaticalOptimization.SymbReg.csproj">
+      <Project>{17A7A380-86CE-482D-8D22-CBD70CC97F0D}</Project>
+      <Name>HeuristicLab.Problems.GrammaticalOptimization.SymbReg</Name>
+    </ProjectReference>
     <ProjectReference Include="..\HeuristicLab.Problems.GrammaticalOptimization\HeuristicLab.Problems.GrammaticalOptimization.csproj">
       <Project>{cb9dccf6-667e-4a13-b82d-dbd6b45a045e}</Project>
